* config/rs6000/rs6000.c (rs6000_delegitimize_address): Check that
[official-gcc.git] / libgo / mksysinfo.sh
blobed585d62f51d65514bd3dbb1a7eee715eea8364e
1 #!/bin/sh
3 # Copyright 2009 The Go Authors. All rights reserved.
4 # Use of this source code is governed by a BSD-style
5 # license that can be found in the LICENSE file.
7 # Create sysinfo.go.
9 # This shell script creates the sysinfo.go file which holds types and
10 # constants extracted from the system header files. This relies on a
11 # hook in gcc: the -fdump-go-spec option will generate debugging
12 # information in Go syntax.
14 # We currently #include all the files at once, which works, but leads
15 # to exposing some names which ideally should not be exposed, as they
16 # match grep patterns. E.g., WCHAR_MIN gets exposed because it starts
17 # with W, like the wait flags.
19 CC=${CC:-gcc}
20 OUT=tmp-sysinfo.go
22 set -e
24 rm -f sysinfo.c
25 cat > sysinfo.c <<EOF
26 #include "config.h"
28 #include <sys/types.h>
29 #include <dirent.h>
30 #include <errno.h>
31 #include <fcntl.h>
32 #include <netinet/in.h>
33 /* <netinet/tcp.h> needs u_char/u_short, but <sys/bsd_types> is only
34 included by <netinet/in.h> if _SGIAPI (i.e. _SGI_SOURCE
35 && !_XOPEN_SOURCE.
36 <sys/termios.h> only defines TIOCNOTTY if !_XOPEN_SOURCE, while
37 <sys/ttold.h> does so unconditionally. */
38 #ifdef __sgi__
39 #include <sys/bsd_types.h>
40 #include <sys/ttold.h>
41 #endif
42 #include <netinet/tcp.h>
43 #if defined(HAVE_NETINET_IN_SYSTM_H)
44 #include <netinet/in_systm.h>
45 #endif
46 #if defined(HAVE_NETINET_IP_H)
47 #include <netinet/ip.h>
48 #endif
49 #if defined(HAVE_NETINET_IP_MROUTE_H)
50 #include <netinet/ip_mroute.h>
51 #endif
52 #if defined(HAVE_NETINET_IF_ETHER_H)
53 #include <netinet/if_ether.h>
54 #endif
55 #include <signal.h>
56 #include <sys/ioctl.h>
57 #include <termios.h>
58 #if defined(HAVE_SYSCALL_H)
59 #include <syscall.h>
60 #endif
61 #if defined(HAVE_SYS_SYSCALL_H)
62 #include <sys/syscall.h>
63 #endif
64 #if defined(HAVE_SYS_EPOLL_H)
65 #include <sys/epoll.h>
66 #endif
67 #if defined(HAVE_SYS_FILE_H)
68 #include <sys/file.h>
69 #endif
70 #if defined(HAVE_SYS_MMAN_H)
71 #include <sys/mman.h>
72 #endif
73 #if defined(HAVE_SYS_PRCTL_H)
74 #include <sys/prctl.h>
75 #endif
76 #if defined(HAVE_SYS_PTRACE_H)
77 #include <sys/ptrace.h>
78 #endif
79 #include <sys/resource.h>
80 #include <sys/uio.h>
81 #include <sys/socket.h>
82 #include <sys/stat.h>
83 #include <sys/time.h>
84 #include <sys/times.h>
85 #include <sys/wait.h>
86 #include <sys/un.h>
87 #if defined(HAVE_SYS_USER_H)
88 #include <sys/user.h>
89 #endif
90 #if defined(HAVE_SYS_UTSNAME_H)
91 #include <sys/utsname.h>
92 #endif
93 #if defined(HAVE_SYS_SELECT_H)
94 #include <sys/select.h>
95 #endif
96 #include <time.h>
97 #include <unistd.h>
98 #include <netdb.h>
99 #include <pwd.h>
100 #if defined(HAVE_LINUX_FILTER_H)
101 #include <linux/filter.h>
102 #endif
103 #if defined(HAVE_LINUX_IF_ADDR_H)
104 #include <linux/if_addr.h>
105 #endif
106 #if defined(HAVE_LINUX_IF_ETHER_H)
107 #include <linux/if_ether.h>
108 #endif
109 #if defined(HAVE_LINUX_IF_TUN_H)
110 #include <linux/if_tun.h>
111 #endif
112 #if defined(HAVE_LINUX_NETLINK_H)
113 #include <linux/netlink.h>
114 #endif
115 #if defined(HAVE_LINUX_RTNETLINK_H)
116 #include <linux/rtnetlink.h>
117 #endif
118 #if defined(HAVE_NET_IF_H)
119 #include <net/if.h>
120 #endif
121 #if defined(HAVE_NET_IF_ARP_H)
122 #include <net/if_arp.h>
123 #endif
124 #if defined(HAVE_NET_ROUTE_H)
125 #include <net/route.h>
126 #endif
127 #if defined (HAVE_NETPACKET_PACKET_H)
128 #include <netpacket/packet.h>
129 #endif
130 #if defined(HAVE_SYS_MOUNT_H)
131 #include <sys/mount.h>
132 #endif
133 #if defined(HAVE_SYS_VFS_H)
134 #include <sys/vfs.h>
135 #endif
136 #if defined(HAVE_STATFS_H)
137 #include <sys/statfs.h>
138 #endif
139 #if defined(HAVE_SYS_TIMEX_H)
140 #include <sys/timex.h>
141 #endif
142 #if defined(HAVE_SYS_SYSINFO_H)
143 #include <sys/sysinfo.h>
144 #endif
145 #if defined(HAVE_USTAT_H)
146 #include <ustat.h>
147 #endif
148 #if defined(HAVE_UTIME_H)
149 #include <utime.h>
150 #endif
151 #if defined(HAVE_LINUX_ETHER_H)
152 #include <linux/ether.h>
153 #endif
154 #if defined(HAVE_LINUX_FS_H)
155 #include <linux/fs.h>
156 #endif
157 #if defined(HAVE_LINUX_REBOOT_H)
158 #include <linux/reboot.h>
159 #endif
160 #if defined(HAVE_SYS_INOTIFY_H)
161 #include <sys/inotify.h>
162 #endif
164 /* Constants that may only be defined as expressions on some systems,
165 expressions too complex for -fdump-go-spec to handle. These are
166 handled specially below. */
167 enum {
168 #ifdef TIOCGWINSZ
169 TIOCGWINSZ_val = TIOCGWINSZ,
170 #endif
171 #ifdef TIOCNOTTY
172 TIOCNOTTY_val = TIOCNOTTY,
173 #endif
174 #ifdef TIOCSCTTY
175 TIOCSCTTY_val = TIOCSCTTY,
176 #endif
180 ${CC} -fdump-go-spec=gen-sysinfo.go -std=gnu99 -S -o sysinfo.s sysinfo.c
182 echo 'package syscall' > ${OUT}
183 echo 'import "unsafe"' >> ${OUT}
184 echo 'type _ unsafe.Pointer' >> ${OUT}
186 # Get all the consts and types, skipping ones which could not be
187 # represented in Go and ones which we need to rewrite. We also skip
188 # function declarations, as we don't need them here. All the symbols
189 # will all have a leading underscore.
190 grep -v '^// ' gen-sysinfo.go | \
191 grep -v '^func' | \
192 grep -v '^type _timeval ' | \
193 grep -v '^type _timespec_t ' | \
194 grep -v '^type _timespec ' | \
195 grep -v '^type _timestruc_t ' | \
196 grep -v '^type _epoll_' | \
197 grep -v 'in6_addr' | \
198 grep -v 'sockaddr_in6' | \
199 sed -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
200 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
201 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
202 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
203 >> ${OUT}
205 # The errno constants. These get type Errno.
206 echo '#include <errno.h>' | ${CC} -x c - -E -dM | \
207 egrep '#define E[A-Z0-9_]+ ' | \
208 sed -e 's/^#define \(E[A-Z0-9_]*\) .*$/const \1 = Errno(_\1)/' >> ${OUT}
210 # The O_xxx flags.
211 egrep '^const _(O|F|FD)_' gen-sysinfo.go | \
212 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
213 if ! grep '^const O_ASYNC' ${OUT} >/dev/null 2>&1; then
214 echo "const O_ASYNC = 0" >> ${OUT}
216 if ! grep '^const O_CLOEXEC' ${OUT} >/dev/null 2>&1; then
217 echo "const O_CLOEXEC = 0" >> ${OUT}
220 # These flags can be lost on i386 GNU/Linux when using
221 # -D_FILE_OFFSET_BITS=64, because we see "#define F_SETLK F_SETLK64"
222 # before we see the definition of F_SETLK64.
223 for flag in F_GETLK F_SETLK F_SETLKW; do
224 if ! grep "^const ${flag} " ${OUT} >/dev/null 2>&1 \
225 && grep "^const ${flag}64 " ${OUT} >/dev/null 2>&1; then
226 echo "const ${flag} = ${flag}64" >> ${OUT}
228 done
230 # The signal numbers.
231 grep '^const _SIG[^_]' gen-sysinfo.go | \
232 grep -v '^const _SIGEV_' | \
233 sed -e 's/^\(const \)_\(SIG[^= ]*\)\(.*\)$/\1\2 = Signal(_\2)/' >> ${OUT}
234 if ! grep '^const SIGPOLL ' ${OUT} >/dev/null 2>&1; then
235 if grep '^const SIGIO ' ${OUT} > /dev/null 2>&1; then
236 echo "const SIGPOLL = SIGIO" >> ${OUT}
239 if ! grep '^const SIGCLD ' ${OUT} >/dev/null 2>&1; then
240 if grep '^const SIGCHLD ' ${OUT} >/dev/null 2>&1; then
241 echo "const SIGCLD = SIGCHLD" >> ${OUT}
245 # The syscall numbers. We force the names to upper case.
246 grep '^const _SYS_' gen-sysinfo.go | \
247 sed -e 's/const _\(SYS_[^= ]*\).*$/\1/' | \
248 while read sys; do
249 sup=`echo $sys | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
250 echo "const $sup = _$sys" >> ${OUT}
251 done
253 # The GNU/Linux support wants to use SYS_GETDENTS64 if available.
254 if ! grep '^const SYS_GETDENTS ' ${OUT} >/dev/null 2>&1; then
255 echo "const SYS_GETDENTS = 0" >> ${OUT}
257 if ! grep '^const SYS_GETDENTS64 ' ${OUT} >/dev/null 2>&1; then
258 echo "const SYS_GETDENTS64 = 0" >> ${OUT}
261 # Stat constants.
262 grep '^const _S_' gen-sysinfo.go | \
263 sed -e 's/^\(const \)_\(S_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
265 # Mmap constants.
266 grep '^const _PROT_' gen-sysinfo.go | \
267 sed -e 's/^\(const \)_\(PROT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
268 grep '^const _MAP_' gen-sysinfo.go | \
269 sed -e 's/^\(const \)_\(MAP_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
270 grep '^const _MADV_' gen-sysinfo.go | \
271 sed -e 's/^\(const \)_\(MADV_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
272 grep '^const _MCL_' gen-sysinfo.go | \
273 sed -e 's/^\(const \)_\(MCL_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
275 # Process status constants.
276 grep '^const _W' gen-sysinfo.go |
277 sed -e 's/^\(const \)_\(W[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
278 # WSTOPPED was introduced in glibc 2.3.4.
279 if ! grep '^const _WSTOPPED = ' gen-sysinfo.go >/dev/null 2>&1; then
280 if grep '^const _WUNTRACED = ' gen-sysinfo.go > /dev/null 2>&1; then
281 echo 'const WSTOPPED = _WUNTRACED' >> ${OUT}
282 else
283 echo 'const WSTOPPED = 2' >> ${OUT}
286 if grep '^const ___WALL = ' gen-sysinfo.go >/dev/null 2>&1 \
287 && ! grep '^const _WALL = ' gen-sysinfo.go >/dev/null 2>&1; then
288 echo 'const WALL = ___WALL' >> ${OUT}
291 # Networking constants.
292 egrep '^const _(AF|ARPHRD|ETH|IN|SOCK|SOL|SO|IPPROTO|TCP|IP|IPV6)_' gen-sysinfo.go |
293 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
294 grep '^const _SOMAXCONN' gen-sysinfo.go |
295 sed -e 's/^\(const \)_\(SOMAXCONN[^= ]*\)\(.*\)$/\1\2 = _\2/' \
296 >> ${OUT}
297 grep '^const _SHUT_' gen-sysinfo.go |
298 sed -e 's/^\(const \)_\(SHUT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
300 # The net package requires some const definitions.
301 for m in IP_PKTINFO IPV6_V6ONLY IPPROTO_IPV6 IPV6_JOIN_GROUP IPV6_LEAVE_GROUP IPV6_TCLASS SO_REUSEPORT; do
302 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
303 echo "const $m = 0" >> ${OUT}
305 done
307 # pathconf constants.
308 grep '^const __PC' gen-sysinfo.go |
309 sed -e 's/^\(const \)__\(PC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
311 # The PATH_MAX constant.
312 if grep '^const _PATH_MAX ' gen-sysinfo.go >/dev/null 2>&1; then
313 echo 'const PathMax = _PATH_MAX' >> ${OUT}
316 # epoll constants.
317 grep '^const _EPOLL' gen-sysinfo.go |
318 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
319 # Make sure EPOLLRDHUP and EPOLL_CLOEXEC are defined.
320 if ! grep '^const EPOLLRDHUP' ${OUT} >/dev/null 2>&1; then
321 echo "const EPOLLRDHUP = 0x2000" >> ${OUT}
323 if ! grep '^const EPOLL_CLOEXEC' ${OUT} >/dev/null 2>&1; then
324 echo "const EPOLL_CLOEXEC = 02000000" >> ${OUT}
327 # Prctl constants.
328 grep '^const _PR_' gen-sysinfo.go |
329 sed -e 's/^\(const \)_\(PR_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
331 # Ptrace constants.
332 grep '^const _PTRACE' gen-sysinfo.go |
333 sed -e 's/^\(const \)_\(PTRACE[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
334 # We need some ptrace options that are not defined in older versions
335 # of glibc.
336 if ! grep '^const PTRACE_SETOPTIONS' ${OUT} > /dev/null 2>&1; then
337 echo "const PTRACE_SETOPTIONS = 0x4200" >> ${OUT}
339 if ! grep '^const PTRACE_O_TRACESYSGOOD' ${OUT} > /dev/null 2>&1; then
340 echo "const PTRACE_O_TRACESYSGOOD = 0x1" >> ${OUT}
342 if ! grep '^const PTRACE_O_TRACEFORK' ${OUT} > /dev/null 2>&1; then
343 echo "const PTRACE_O_TRACEFORK = 0x2" >> ${OUT}
345 if ! grep '^const PTRACE_O_TRACEVFORK' ${OUT} > /dev/null 2>&1; then
346 echo "const PTRACE_O_TRACEVFORK = 0x4" >> ${OUT}
348 if ! grep '^const PTRACE_O_TRACECLONE' ${OUT} > /dev/null 2>&1; then
349 echo "const PTRACE_O_TRACECLONE = 0x8" >> ${OUT}
351 if ! grep '^const PTRACE_O_TRACEEXEC' ${OUT} > /dev/null 2>&1; then
352 echo "const PTRACE_O_TRACEEXEC = 0x10" >> ${OUT}
354 if ! grep '^const PTRACE_O_TRACEVFORKDONE' ${OUT} > /dev/null 2>&1; then
355 echo "const PTRACE_O_TRACEVFORKDONE = 0x20" >> ${OUT}
357 if ! grep '^const PTRACE_O_TRACEEXIT' ${OUT} > /dev/null 2>&1; then
358 echo "const PTRACE_O_TRACEEXIT = 0x40" >> ${OUT}
360 if ! grep '^const PTRACE_O_MASK' ${OUT} > /dev/null 2>&1; then
361 echo "const PTRACE_O_MASK = 0x7f" >> ${OUT}
363 if ! grep '^const _PTRACE_GETEVENTMSG' ${OUT} > /dev/null 2>&1; then
364 echo "const PTRACE_GETEVENTMSG = 0x4201" >> ${OUT}
366 if ! grep '^const PTRACE_EVENT_FORK' ${OUT} > /dev/null 2>&1; then
367 echo "const PTRACE_EVENT_FORK = 1" >> ${OUT}
369 if ! grep '^const PTRACE_EVENT_VFORK' ${OUT} > /dev/null 2>&1; then
370 echo "const PTRACE_EVENT_VFORK = 2" >> ${OUT}
372 if ! grep '^const PTRACE_EVENT_CLONE' ${OUT} > /dev/null 2>&1; then
373 echo "const PTRACE_EVENT_CLONE = 3" >> ${OUT}
375 if ! grep '^const PTRACE_EVENT_EXEC' ${OUT} > /dev/null 2>&1; then
376 echo "const PTRACE_EVENT_EXEC = 4" >> ${OUT}
378 if ! grep '^const PTRACE_EVENT_VFORK_DONE' ${OUT} > /dev/null 2>&1; then
379 echo "const PTRACE_EVENT_VFORK_DONE = 5" >> ${OUT}
381 if ! grep '^const PTRACE_EVENT_EXIT' ${OUT} > /dev/null 2>&1; then
382 echo "const PTRACE_EVENT_EXIT = 6" >> ${OUT}
384 if ! grep '^const _PTRACE_TRACEME' ${OUT} > /dev/null 2>&1; then
385 echo "const _PTRACE_TRACEME = 0" >> ${OUT}
388 # The registers returned by PTRACE_GETREGS. This is probably
389 # GNU/Linux specific; it should do no harm if there is no
390 # _user_regs_struct.
391 regs=`grep '^type _user_regs_struct struct' gen-sysinfo.go || true`
392 if test "$regs" != ""; then
393 regs=`echo $regs | sed -e 's/type _user_regs_struct struct //' -e 's/[{}]//g'`
394 regs=`echo $regs | sed -e s'/^ *//'`
395 nregs=
396 while test -n "$regs"; do
397 field=`echo $regs | sed -e 's/^\([^;]*\);.*$/\1/'`
398 regs=`echo $regs | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
399 # Capitalize the first character of the field.
400 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
401 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
402 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
403 field="$f$r"
404 nregs="$nregs $field;"
405 done
406 echo "type PtraceRegs struct {$nregs }" >> ${OUT}
409 # Some basic types.
410 echo 'type Size_t _size_t' >> ${OUT}
411 echo "type Ssize_t _ssize_t" >> ${OUT}
412 if grep '^const _HAVE_OFF64_T = ' gen-sysinfo.go > /dev/null 2>&1; then
413 echo "type Offset_t _off64_t" >> ${OUT}
414 else
415 echo "type Offset_t _off_t" >> ${OUT}
417 echo "type Mode_t _mode_t" >> ${OUT}
418 echo "type Pid_t _pid_t" >> ${OUT}
419 echo "type Uid_t _uid_t" >> ${OUT}
420 echo "type Gid_t _gid_t" >> ${OUT}
421 echo "type Socklen_t _socklen_t" >> ${OUT}
423 # The C int type.
424 sizeof_int=`grep '^const ___SIZEOF_INT__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
425 if test "$sizeof_int" = "4"; then
426 echo "type _C_int int32" >> ${OUT}
427 elif test "$sizeof_int" = "8"; then
428 echo "type _C_int int64" >> ${OUT}
429 else
430 echo 1>&2 "mksysinfo.sh: could not determine size of int (got $sizeof_int)"
431 exit 1
434 # The C long type, needed because that is the type that ptrace returns.
435 sizeof_long=`grep '^const ___SIZEOF_LONG__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
436 if test "$sizeof_long" = "4"; then
437 echo "type _C_long int32" >> ${OUT}
438 elif test "$sizeof_long" = "8"; then
439 echo "type _C_long int64" >> ${OUT}
440 else
441 echo 1>&2 "mksysinfo.sh: could not determine size of long (got $sizeof_long)"
442 exit 1
445 # Solaris 2 needs _u?pad128_t, but its default definition in terms of long
446 # double is commented by -fdump-go-spec.
447 if grep "^// type _pad128_t" gen-sysinfo.go > /dev/null 2>&1; then
448 echo "type _pad128_t struct { _l [4]int32; }" >> ${OUT}
450 if grep "^// type _upad128_t" gen-sysinfo.go > /dev/null 2>&1; then
451 echo "type _upad128_t struct { _l [4]uint32; }" >> ${OUT}
454 # The time_t type.
455 if grep '^type _time_t ' gen-sysinfo.go > /dev/null 2>&1; then
456 echo 'type Time_t _time_t' >> ${OUT}
459 # The time structures need special handling: we need to name the
460 # types, so that we can cast integers to the right types when
461 # assigning to the structures.
462 timeval=`grep '^type _timeval ' gen-sysinfo.go`
463 timeval_sec=`echo $timeval | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
464 timeval_usec=`echo $timeval | sed -n -e 's/^.*tv_usec \([^ ]*\);.*$/\1/p'`
465 echo "type Timeval_sec_t $timeval_sec" >> ${OUT}
466 echo "type Timeval_usec_t $timeval_usec" >> ${OUT}
467 echo $timeval | \
468 sed -e 's/type _timeval /type Timeval /' \
469 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timeval_sec_t/' \
470 -e 's/tv_usec *[a-zA-Z0-9_]*/Usec Timeval_usec_t/' >> ${OUT}
471 timespec=`grep '^type _timespec ' gen-sysinfo.go || true`
472 if test "$timespec" = ""; then
473 # IRIX 6.5 has __timespec instead.
474 timespec=`grep '^type ___timespec ' gen-sysinfo.go || true`
476 timespec_sec=`echo $timespec | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
477 timespec_nsec=`echo $timespec | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
478 echo "type Timespec_sec_t $timespec_sec" >> ${OUT}
479 echo "type Timespec_nsec_t $timespec_nsec" >> ${OUT}
480 echo $timespec | \
481 sed -e 's/^type ___timespec /type Timespec /' \
482 -e 's/^type _timespec /type Timespec /' \
483 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timespec_sec_t/' \
484 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timespec_nsec_t/' >> ${OUT}
486 timestruc=`grep '^type _timestruc_t ' gen-sysinfo.go || true`
487 if test "$timestruc" != ""; then
488 timestruc_sec=`echo $timestruc | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
489 timestruc_nsec=`echo $timestruc | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
490 echo "type Timestruc_sec_t $timestruc_sec" >> ${OUT}
491 echo "type Timestruc_nsec_t $timestruc_nsec" >> ${OUT}
492 echo $timestruc | \
493 sed -e 's/^type _timestruc_t /type Timestruc /' \
494 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timestruc_sec_t/' \
495 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timestruc_nsec_t/' >> ${OUT}
498 # The tms struct.
499 grep '^type _tms ' gen-sysinfo.go | \
500 sed -e 's/type _tms/type Tms/' \
501 -e 's/tms_utime/Utime/' \
502 -e 's/tms_stime/Stime/' \
503 -e 's/tms_cutime/Cutime/' \
504 -e 's/tms_cstime/Cstime/' \
505 >> ${OUT}
507 # The stat type.
508 # Prefer largefile variant if available.
509 stat=`grep '^type _stat64 ' gen-sysinfo.go || true`
510 if test "$stat" != ""; then
511 grep '^type _stat64 ' gen-sysinfo.go
512 else
513 grep '^type _stat ' gen-sysinfo.go
514 fi | sed -e 's/type _stat64/type Stat_t/' \
515 -e 's/type _stat/type Stat_t/' \
516 -e 's/st_dev/Dev/' \
517 -e 's/st_ino/Ino/g' \
518 -e 's/st_nlink/Nlink/' \
519 -e 's/st_mode/Mode/' \
520 -e 's/st_uid/Uid/' \
521 -e 's/st_gid/Gid/' \
522 -e 's/st_rdev/Rdev/' \
523 -e 's/st_size/Size/' \
524 -e 's/st_blksize/Blksize/' \
525 -e 's/st_blocks/Blocks/' \
526 -e 's/st_atim/Atim/' \
527 -e 's/st_mtim/Mtim/' \
528 -e 's/st_ctim/Ctim/' \
529 -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
530 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
531 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
532 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
533 -e 's/Godump_[0-9] struct { \([^;]*;\) };/\1/g' \
534 >> ${OUT}
536 # The directory searching types.
537 # Prefer largefile variant if available.
538 dirent=`grep '^type _dirent64 ' gen-sysinfo.go || true`
539 if test "$dirent" != ""; then
540 grep '^type _dirent64 ' gen-sysinfo.go
541 else
542 grep '^type _dirent ' gen-sysinfo.go
543 fi | sed -e 's/type _dirent64/type Dirent/' \
544 -e 's/type _dirent/type Dirent/' \
545 -e 's/d_name \[0+1\]/d_name [0+256]/' \
546 -e 's/d_name/Name/' \
547 -e 's/]int8/]byte/' \
548 -e 's/d_ino/Ino/' \
549 -e 's/d_off/Off/' \
550 -e 's/d_reclen/Reclen/' \
551 -e 's/d_type/Type/' \
552 >> ${OUT}
553 echo "type DIR _DIR" >> ${OUT}
555 # Values for d_type field in dirent.
556 grep '^const _DT_' gen-sysinfo.go |
557 sed -e 's/^\(const \)_\(DT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
559 # The rusage struct.
560 rusage=`grep '^type _rusage struct' gen-sysinfo.go`
561 if test "$rusage" != ""; then
562 # Remove anonymous unions from GNU/Linux <bits/resource.h>.
563 rusage=`echo $rusage | sed -e 's/Godump_[0-9]* struct {\([^}]*\)};/\1/g'`
564 rusage=`echo $rusage | sed -e 's/type _rusage struct //' -e 's/[{}]//g'`
565 rusage=`echo $rusage | sed -e 's/^ *//'`
566 nrusage=
567 while test -n "$rusage"; do
568 field=`echo $rusage | sed -e 's/^\([^;]*\);.*$/\1/'`
569 rusage=`echo $rusage | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
570 # Drop the leading ru_, capitalize the next character.
571 field=`echo $field | sed -e 's/^ru_//'`
572 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
573 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
574 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
575 # Fix _timeval _timespec, and _timestruc_t.
576 r=`echo $r | sed -e s'/ _timeval$/ Timeval/'`
577 r=`echo $r | sed -e s'/ _timespec$/ Timespec/'`
578 r=`echo $r | sed -e s'/ _timestruc_t$/ Timestruc/'`
579 field="$f$r"
580 nrusage="$nrusage $field;"
581 done
582 echo "type Rusage struct {$nrusage }" >> ${OUT}
583 else
584 echo "type Rusage struct {}" >> ${OUT}
587 # The RUSAGE constants.
588 grep '^const _RUSAGE_' gen-sysinfo.go | \
589 sed -e 's/^\(const \)_\(RUSAGE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
591 # The utsname struct.
592 grep '^type _utsname ' gen-sysinfo.go | \
593 sed -e 's/_utsname/Utsname/' \
594 -e 's/sysname/Sysname/' \
595 -e 's/nodename/Nodename/' \
596 -e 's/release/Release/' \
597 -e 's/version/Version/' \
598 -e 's/machine/Machine/' \
599 -e 's/domainname/Domainname/' \
600 >> ${OUT}
602 # The iovec struct.
603 iovec=`grep '^type _iovec ' gen-sysinfo.go`
604 iovec_len=`echo $iovec | sed -n -e 's/^.*iov_len \([^ ]*\);.*$/\1/p'`
605 echo "type Iovec_len_t $iovec_len" >> ${OUT}
606 echo $iovec | \
607 sed -e 's/_iovec/Iovec/' \
608 -e 's/iov_base/Base/' \
609 -e 's/iov_len *[a-zA-Z0-9_]*/Len Iovec_len_t/' \
610 >> ${OUT}
612 # The msghdr struct.
613 msghdr=`grep '^type _msghdr ' gen-sysinfo.go`
614 msghdr_controllen=`echo $msghdr | sed -n -e 's/^.*msg_controllen \([^ ]*\);.*$/\1/p'`
615 echo "type Msghdr_controllen_t $msghdr_controllen" >> ${OUT}
616 echo $msghdr | \
617 sed -e 's/_msghdr/Msghdr/' \
618 -e 's/msg_name/Name/' \
619 -e 's/msg_namelen/Namelen/' \
620 -e 's/msg_iov/Iov/' \
621 -e 's/msg_iovlen/Iovlen/' \
622 -e 's/_iovec/Iovec/' \
623 -e 's/msg_control/Control/' \
624 -e 's/msg_controllen *[a-zA-Z0-9_]*/Controllen Msghdr_controllen_t/' \
625 -e 's/msg_flags/Flags/' \
626 >> ${OUT}
628 # The MSG_ flags for Msghdr.
629 grep '^const _MSG_' gen-sysinfo.go | \
630 sed -e 's/^\(const \)_\(MSG_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
632 # The cmsghdr struct.
633 cmsghdr=`grep '^type _cmsghdr ' gen-sysinfo.go`
634 if test -n "$cmsghdr"; then
635 cmsghdr_len=`echo $cmsghdr | sed -n -e 's/^.*cmsg_len \([^ ]*\);.*$/\1/p'`
636 echo "type Cmsghdr_len_t $cmsghdr_len" >> ${OUT}
637 echo "$cmsghdr" | \
638 sed -e 's/_cmsghdr/Cmsghdr/' \
639 -e 's/cmsg_len *[a-zA-Z0-9_]*/Len Cmsghdr_len_t/' \
640 -e 's/cmsg_level/Level/' \
641 -e 's/cmsg_type/Type/' \
642 -e 's/\[\]/[0]/' \
643 >> ${OUT}
646 # The SCM_ flags for Cmsghdr.
647 grep '^const _SCM_' gen-sysinfo.go | \
648 sed -e 's/^\(const \)_\(SCM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
650 # The ucred struct.
651 grep '^type _ucred ' gen-sysinfo.go | \
652 sed -e 's/_ucred/Ucred/' \
653 -e 's/pid/Pid/' \
654 -e 's/uid/Uid/' \
655 -e 's/gid/Gid/' \
656 >> ${OUT}
658 # The ip_mreq struct.
659 grep '^type _ip_mreq ' gen-sysinfo.go | \
660 sed -e 's/_ip_mreq/IPMreq/' \
661 -e 's/imr_multiaddr/Multiaddr/' \
662 -e 's/imr_interface/Interface/' \
663 -e 's/_in_addr/[4]byte/g' \
664 >> ${OUT}
666 # We need IPMreq to compile the net package.
667 if ! grep 'type IPMreq ' ${OUT} >/dev/null 2>&1; then
668 echo 'type IPMreq struct { Multiaddr [4]byte; Interface [4]byte; }' >> ${OUT}
671 # The ipv6_mreq struct.
672 grep '^type _ipv6_mreq ' gen-sysinfo.go | \
673 sed -e 's/_ipv6_mreq/IPv6Mreq/' \
674 -e 's/ipv6mr_multiaddr/Multiaddr/' \
675 -e 's/ipv6mr_interface/Interface/' \
676 -e 's/_in6_addr/[16]byte/' \
677 >> ${OUT}
679 # We need IPv6Mreq to compile the net package.
680 if ! grep 'type IPv6Mreq ' ${OUT} >/dev/null 2>&1; then
681 echo 'type IPv6Mreq struct { Multiaddr [16]byte; Interface uint32; }' >> ${OUT}
684 # The ip_mreqn struct.
685 grep '^type _ip_mreqn ' gen-sysinfo.go | \
686 sed -e 's/_ip_mreqn/IPMreqn/' \
687 -e 's/imr_multiaddr/Multiaddr/' \
688 -e 's/imr_address/Address/' \
689 -e 's/imr_ifindex/Ifindex/' \
690 -e 's/_in_addr/[4]byte/g' \
691 >> ${OUT}
693 # We need IPMreq to compile the net package.
694 if ! grep 'type IPMreqn ' ${OUT} >/dev/null 2>&1; then
695 echo 'type IPMreqn struct { Multiaddr [4]byte; Interface [4]byte; Ifindex int32 }' >> ${OUT}
698 # Try to guess the type to use for fd_set.
699 fd_set=`grep '^type _fd_set ' gen-sysinfo.go || true`
700 fds_bits_type="_C_long"
701 if test "$fd_set" != ""; then
702 fds_bits_type=`echo $fd_set | sed -e 's/.*[]]\([^;]*\); }$/\1/'`
704 echo "type fds_bits_type $fds_bits_type" >> ${OUT}
706 # The addrinfo struct.
707 grep '^type _addrinfo ' gen-sysinfo.go | \
708 sed -e 's/_addrinfo/Addrinfo/g' \
709 -e 's/ ai_/ Ai_/g' \
710 >> ${OUT}
712 # The addrinfo flags and errors.
713 grep '^const _AI_' gen-sysinfo.go | \
714 sed -e 's/^\(const \)_\(AI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
715 grep '^const _EAI_' gen-sysinfo.go | \
716 sed -e 's/^\(const \)_\(EAI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
718 # The passwd struct.
719 grep '^type _passwd ' gen-sysinfo.go | \
720 sed -e 's/_passwd/Passwd/' \
721 -e 's/ pw_/ Pw_/g' \
722 >> ${OUT}
724 # The ioctl flags for the controlling TTY.
725 grep '^const _TIOC' gen-sysinfo.go | \
726 grep -v '_val =' | \
727 sed -e 's/^\(const \)_\(TIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
728 # We need TIOCGWINSZ.
729 if ! grep '^const TIOCGWINSZ' ${OUT} >/dev/null 2>&1; then
730 if grep '^const _TIOCGWINSZ_val' ${OUT} >/dev/null 2>&1; then
731 echo 'const TIOCGWINSZ = _TIOCGWINSZ_val' >> ${OUT}
734 if ! grep '^const TIOCNOTTY' ${OUT} >/dev/null 2>&1; then
735 if grep '^const _TIOCNOTTY_val' ${OUT} >/dev/null 2>&1; then
736 echo 'const TIOCNOTTY = _TIOCNOTTY_val' >> ${OUT}
739 if ! grep '^const TIOCSCTTY' ${OUT} >/dev/null 2>&1; then
740 if grep '^const _TIOCSCTTY_val' ${OUT} >/dev/null 2>&1; then
741 echo 'const TIOCSCTTY = _TIOCSCTTY_val' >> ${OUT}
745 # The ioctl flags for terminal control
746 grep '^const _TC[GS]ET' gen-sysinfo.go | \
747 sed -e 's/^\(const \)_\(TC[GS]ET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
749 # ioctl constants. Might fall back to 0 if TIOCNXCL is missing, too, but
750 # needs handling in syscalls.exec.go.
751 if ! grep '^const _TIOCSCTTY ' gen-sysinfo.go >/dev/null 2>&1; then
752 if grep '^const _TIOCNXCL ' gen-sysinfo.go >/dev/null 2>&1; then
753 echo "const TIOCSCTTY = TIOCNXCL" >> ${OUT}
757 # The nlmsghdr struct.
758 grep '^type _nlmsghdr ' gen-sysinfo.go | \
759 sed -e 's/_nlmsghdr/NlMsghdr/' \
760 -e 's/nlmsg_len/Len/' \
761 -e 's/nlmsg_type/Type/' \
762 -e 's/nlmsg_flags/Flags/' \
763 -e 's/nlmsg_seq/Seq/' \
764 -e 's/nlmsg_pid/Pid/' \
765 >> ${OUT}
767 # The nlmsg flags and operators.
768 grep '^const _NLM' gen-sysinfo.go | \
769 sed -e 's/^\(const \)_\(NLM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
771 # NLMSG_HDRLEN is defined as an expression using sizeof.
772 if ! grep '^const NLMSG_HDRLEN' ${OUT} > /dev/null 2>&1; then
773 if grep '^const _sizeof_nlmsghdr ' ${OUT} > /dev/null 2>&1; then
774 echo 'const NLMSG_HDRLEN = (_sizeof_nlmsghdr + (NLMSG_ALIGNTO-1)) &^ (NLMSG_ALIGNTO-1)' >> ${OUT}
778 # The rtmsg struct.
779 grep '^type _rtmsg ' gen-sysinfo.go | \
780 sed -e 's/_rtmsg/RtMsg/' \
781 -e 's/rtm_family/Family/' \
782 -e 's/rtm_dst_len/Dst_len/' \
783 -e 's/rtm_src_len/Src_len/' \
784 -e 's/rtm_tos/Tos/' \
785 -e 's/rtm_table/Table/' \
786 -e 's/rtm_protocol/Protocol/' \
787 -e 's/rtm_scope/Scope/' \
788 -e 's/rtm_type/Type/' \
789 -e 's/rtm_flags/Flags/' \
790 >> ${OUT}
792 # The rtgenmsg struct.
793 grep '^type _rtgenmsg ' gen-sysinfo.go | \
794 sed -e 's/_rtgenmsg/RtGenmsg/' \
795 -e 's/rtgen_family/Family/' \
796 >> ${OUT}
798 # The routing message flags.
799 grep '^const _RT_' gen-sysinfo.go | \
800 sed -e 's/^\(const \)_\(RT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
801 grep '^const _RTA' gen-sysinfo.go | \
802 sed -e 's/^\(const \)_\(RTA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
803 grep '^const _RTF' gen-sysinfo.go | \
804 sed -e 's/^\(const \)_\(RTF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
805 grep '^const _RTCF' gen-sysinfo.go | \
806 sed -e 's/^\(const \)_\(RTCF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
807 grep '^const _RTM' gen-sysinfo.go | \
808 sed -e 's/^\(const \)_\(RTM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
809 grep '^const _RTN' gen-sysinfo.go | \
810 sed -e 's/^\(const \)_\(RTN[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
811 grep '^const _RTPROT' gen-sysinfo.go | \
812 sed -e 's/^\(const \)_\(RTPROT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
814 # The ifinfomsg struct.
815 grep '^type _ifinfomsg ' gen-sysinfo.go | \
816 sed -e 's/_ifinfomsg/IfInfomsg/' \
817 -e 's/ifi_family/Family/' \
818 -e 's/ifi_type/Type/' \
819 -e 's/ifi_index/Index/' \
820 -e 's/ifi_flags/Flags/' \
821 -e 's/ifi_change/Change/' \
822 >> ${OUT}
824 # The interface information types and flags.
825 grep '^const _IFA' gen-sysinfo.go | \
826 sed -e 's/^\(const \)_\(IFA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
827 grep '^const _IFLA' gen-sysinfo.go | \
828 sed -e 's/^\(const \)_\(IFLA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
829 grep '^const _IFF' gen-sysinfo.go | \
830 sed -e 's/^\(const \)_\(IFF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
831 grep '^const _IFNAMSIZ' gen-sysinfo.go | \
832 sed -e 's/^\(const \)_\(IFNAMSIZ[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
833 grep '^const _SIOC' gen-sysinfo.go |
834 sed -e 's/^\(const \)_\(SIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
836 # The ifaddrmsg struct.
837 grep '^type _ifaddrmsg ' gen-sysinfo.go | \
838 sed -e 's/_ifaddrmsg/IfAddrmsg/' \
839 -e 's/ifa_family/Family/' \
840 -e 's/ifa_prefixlen/Prefixlen/' \
841 -e 's/ifa_flags/Flags/' \
842 -e 's/ifa_scope/Scope/' \
843 -e 's/ifa_index/Index/' \
844 >> ${OUT}
846 # The rtattr struct.
847 grep '^type _rtattr ' gen-sysinfo.go | \
848 sed -e 's/_rtattr/RtAttr/' \
849 -e 's/rta_len/Len/' \
850 -e 's/rta_type/Type/' \
851 >> ${OUT}
853 # The in_pktinfo struct.
854 grep '^type _in_pktinfo ' gen-sysinfo.go | \
855 sed -e 's/_in_pktinfo/Inet4Pktinfo/' \
856 -e 's/ipi_ifindex/Ifindex/' \
857 -e 's/ipi_spec_dst/Spec_dst/' \
858 -e 's/ipi_addr/Addr/' \
859 -e 's/_in_addr/[4]byte/g' \
860 >> ${OUT}
862 # The in6_pktinfo struct.
863 grep '^type _in6_pktinfo ' gen-sysinfo.go | \
864 sed -e 's/_in6_pktinfo/Inet6Pktinfo/' \
865 -e 's/ipi6_addr/Addr/' \
866 -e 's/ipi6_ifindex/Ifindex/' \
867 -e 's/_in6_addr/[16]byte/' \
868 >> ${OUT}
870 # The termios struct.
871 grep '^type _termios ' gen-sysinfo.go | \
872 sed -e 's/_termios/Termios/' \
873 -e 's/c_iflag/Iflag/' \
874 -e 's/c_oflag/Oflag/' \
875 -e 's/c_cflag/Cflag/' \
876 -e 's/c_lflag/Lflag/' \
877 -e 's/c_line/Line/' \
878 -e 's/c_cc/Cc/' \
879 -e 's/c_ispeed/Ispeed/' \
880 -e 's/c_ospeed/Ospeed/' \
881 >> ${OUT}
883 # The termios constants.
884 for n in IGNBRK BRKINT IGNPAR PARMRK INPCK ISTRIP INLCR IGNCR ICRNL IUCLC \
885 IXON IXANY IXOFF IMAXBEL IUTF8 OPOST OLCUC ONLCR OCRNL ONOCR ONLRET \
886 OFILL OFDEL NLDLY NL0 NL1 CRDLY CR0 CR1 CR2 CR3 CS5 CS6 CS7 CS8 TABDLY \
887 BSDLY VTDLY FFDLY CBAUD CBAUDEX CSIZE CSTOPB CREAD PARENB PARODD HUPCL \
888 CLOCAL LOBLK CIBAUD CMSPAR CRTSCTS ISIG ICANON XCASE ECHO ECHOE ECHOK \
889 ECHONL ECHOCTL ECHOPRT ECHOKE DEFECHO FLUSHO NOFLSH TOSTOP PENDIN IEXTEN \
890 VINTR VQUIT VERASE VKILL VEOF VMIN VEOL VTIME VEOL2 VSWTCH VSTART VSTOP \
891 VSUSP VDSUSP VLNEXT VWERASE VREPRINT VDISCARD VSTATUS TCSANOW TCSADRAIN \
892 TCSAFLUSH TCIFLUSH TCOFLUSH TCIOFLUSH TCOOFF TCOON TCIOFF TCION B0 B50 \
893 B75 B110 B134 B150 B200 B300 B600 B1200 B1800 B2400 B4800 B9600 B19200 \
894 B38400 B57600 B115200 B230400 B460800 B500000 B576000 B921600 B1000000 \
895 B1152000 B1500000 B2000000 B2500000 B3000000 B3500000 B4000000; do
897 grep "^const _$n " gen-sysinfo.go | \
898 sed -e 's/^\(const \)_\([^=]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
899 done
901 # The mount flags
902 grep '^const _MNT_' gen-sysinfo.go |
903 sed -e 's/^\(const \)_\(MNT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
904 grep '^const _MS_' gen-sysinfo.go |
905 sed -e 's/^\(const \)_\(MS_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
907 # The fallocate flags.
908 grep '^const _FALLOC_' gen-sysinfo.go |
909 sed -e 's/^\(const \)_\(FALLOC_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
911 # The statfs struct.
912 # Prefer largefile variant if available.
913 statfs=`grep '^type _statfs64 ' gen-sysinfo.go || true`
914 if test "$statfs" != ""; then
915 grep '^type _statfs64 ' gen-sysinfo.go
916 else
917 grep '^type _statfs ' gen-sysinfo.go
918 fi | sed -e 's/type _statfs64/type Statfs_t/' \
919 -e 's/type _statfs/type Statfs_t/' \
920 -e 's/f_type/Type/' \
921 -e 's/f_bsize/Bsize/' \
922 -e 's/f_blocks/Blocks/' \
923 -e 's/f_bfree/Bfree/' \
924 -e 's/f_bavail/Bavail/' \
925 -e 's/f_files/Files/' \
926 -e 's/f_ffree/Ffree/' \
927 -e 's/f_fsid/Fsid/' \
928 -e 's/f_namelen/Namelen/' \
929 -e 's/f_frsize/Frsize/' \
930 -e 's/f_flags/Flags/' \
931 -e 's/f_spare/Spare/' \
932 >> ${OUT}
934 # The timex struct.
935 timex=`grep '^type _timex ' gen-sysinfo.go || true`
936 if test "$timex" = ""; then
937 timex=`grep '^// type _timex ' gen-sysinfo.go || true`
938 if test "$timex" != ""; then
939 timex=`echo $timex | sed -e 's|// ||' -e 's/INVALID-bit-field/int32/g'`
942 if test "$timex" != ""; then
943 echo "$timex" | \
944 sed -e 's/_timex/Timex/' \
945 -e 's/modes/Modes/' \
946 -e 's/offset/Offset/' \
947 -e 's/freq/Freq/' \
948 -e 's/maxerror/Maxerror/' \
949 -e 's/esterror/Esterror/' \
950 -e 's/status/Status/' \
951 -e 's/constant/Constant/' \
952 -e 's/precision/Precision/' \
953 -e 's/tolerance/Tolerance/' \
954 -e 's/ time / Time /' \
955 -e 's/tick/Tick/' \
956 -e 's/ppsfreq/Ppsfreq/' \
957 -e 's/jitter/Jitter/' \
958 -e 's/shift/Shift/' \
959 -e 's/stabil/Stabil/' \
960 -e 's/jitcnt/Jitcnt/' \
961 -e 's/calcnt/Calcnt/' \
962 -e 's/errcnt/Errcnt/' \
963 -e 's/stbcnt/Stbcnt/' \
964 -e 's/tai/Tai/' \
965 -e 's/_timeval/Timeval/' \
966 >> ${OUT}
969 # The rlimit struct.
970 grep '^type _rlimit ' gen-sysinfo.go | \
971 sed -e 's/_rlimit/Rlimit/' \
972 -e 's/rlim_cur/Cur/' \
973 -e 's/rlim_max/Max/' \
974 >> ${OUT}
976 # The RLIMIT constants.
977 grep '^const _RLIMIT_' gen-sysinfo.go |
978 sed -e 's/^\(const \)_\(RLIMIT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
979 grep '^const _RLIM_' gen-sysinfo.go |
980 sed -e 's/^\(const \)_\(RLIM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
982 # The sysinfo struct.
983 grep '^type _sysinfo ' gen-sysinfo.go | \
984 sed -e 's/_sysinfo/Sysinfo_t/' \
985 -e 's/uptime/Uptime/' \
986 -e 's/loads/Loads/' \
987 -e 's/totalram/Totalram/' \
988 -e 's/freeram/Freeram/' \
989 -e 's/sharedram/Sharedram/' \
990 -e 's/bufferram/Bufferram/' \
991 -e 's/totalswap/Totalswap/' \
992 -e 's/freeswap/Freeswap/' \
993 -e 's/procs/Procs/' \
994 -e 's/totalhigh/Totalhigh/' \
995 -e 's/freehigh/Freehigh/' \
996 -e 's/mem_unit/Unit/' \
997 >> ${OUT}
999 # The ustat struct.
1000 grep '^type _ustat ' gen-sysinfo.go | \
1001 sed -e 's/_ustat/Ustat_t/' \
1002 -e 's/f_tfree/Tfree/' \
1003 -e 's/f_tinode/Tinoe/' \
1004 -e 's/f_fname/Fname/' \
1005 -e 's/f_fpack/Fpack/' \
1006 >> ${OUT}
1007 # Force it to be defined, as on some older GNU/Linux systems the
1008 # header file fails when using with <linux/filter.h>.
1009 if ! grep 'type _ustat ' gen-sysinfo.go >/dev/null 2>&1; then
1010 echo 'type Ustat_t struct { Tfree int32; Tinoe uint64; Fname [5+1]int8; Fpack [5+1]int8; }' >> ${OUT}
1013 # The utimbuf struct.
1014 grep '^type _utimbuf ' gen-sysinfo.go | \
1015 sed -e 's/_utimbuf/Utimbuf/' \
1016 -e 's/actime/Actime/' \
1017 -e 's/modtime/Modtime/' \
1018 >> ${OUT}
1020 # The LOCK flags for flock.
1021 grep '^const _LOCK_' gen-sysinfo.go |
1022 sed -e 's/^\(const \)_\(LOCK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1024 # The GNU/Linux LINUX_REBOOT flags.
1025 grep '^const _LINUX_REBOOT_' gen-sysinfo.go |
1026 sed -e 's/^\(const \)_\(LINUX_REBOOT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1028 # The GNU/Linux sock_filter struct.
1029 grep '^type _sock_filter ' gen-sysinfo.go | \
1030 sed -e 's/_sock_filter/SockFilter/' \
1031 -e 's/code/Code/' \
1032 -e 's/jt/Jt/' \
1033 -e 's/jf/Jf/' \
1034 -e 's/k /K /' \
1035 >> ${OUT}
1037 # The GNU/Linux sock_fprog struct.
1038 grep '^type _sock_fprog ' gen-sysinfo.go | \
1039 sed -e 's/_sock_fprog/SockFprog/' \
1040 -e 's/len/Len/' \
1041 -e 's/filter/Filter/' \
1042 -e 's/_sock_filter/SockFilter/' \
1043 >> ${OUT}
1045 # The GNU/Linux filter flags.
1046 grep '^const _BPF_' gen-sysinfo.go | \
1047 sed -e 's/^\(const \)_\(BPF_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1049 # The GNU/Linux nlattr struct.
1050 grep '^type _nlattr ' gen-sysinfo.go | \
1051 sed -e 's/_nlattr/NlAttr/' \
1052 -e 's/nla_len/Len/' \
1053 -e 's/nla_type/Type/' \
1054 >> ${OUT}
1056 # The GNU/Linux nlmsgerr struct.
1057 grep '^type _nlmsgerr ' gen-sysinfo.go | \
1058 sed -e 's/_nlmsgerr/NlMsgerr/' \
1059 -e 's/error/Error/' \
1060 -e 's/msg/Msg/' \
1061 -e 's/_nlmsghdr/NlMsghdr/' \
1062 >> ${OUT}
1064 # The GNU/Linux rtnexthop struct.
1065 grep '^type _rtnexthop ' gen-sysinfo.go | \
1066 sed -e 's/_rtnexthop/RtNexthop/' \
1067 -e 's/rtnh_len/Len/' \
1068 -e 's/rtnh_flags/Flags/' \
1069 -e 's/rtnh_hops/Hops/' \
1070 -e 's/rtnh_ifindex/Ifindex/' \
1071 >> ${OUT}
1073 # The GNU/Linux netlink flags.
1074 grep '^const _NETLINK_' gen-sysinfo.go | \
1075 sed -e 's/^\(const \)_\(NETLINK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1076 grep '^const _NLA_' gen-sysinfo.go | \
1077 sed -e 's/^\(const \)_\(NLA_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1079 # The GNU/Linux packet socket flags.
1080 grep '^const _PACKET_' gen-sysinfo.go | \
1081 sed -e 's/^\(const \)_\(PACKET_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1083 # The GNU/Linux inotify_event struct.
1084 grep '^type _inotify_event ' gen-sysinfo.go | \
1085 sed -e 's/_inotify_event/InotifyEvent/' \
1086 -e 's/wd/Wd/' \
1087 -e 's/mask/Mask/' \
1088 -e 's/cookie/Cookie/' \
1089 -e 's/len/Len/' \
1090 -e 's/name/Name/' \
1091 -e 's/\[\]/[0]/' \
1092 -e 's/\[0\]byte/[0]int8/' \
1093 >> ${OUT}
1095 # The Solaris 11 Update 1 _zone_net_addr_t struct.
1096 grep '^type _zone_net_addr_t ' gen-sysinfo.go | \
1097 sed -e 's/_in6_addr/[16]byte/' \
1098 >> ${OUT}
1100 # Struct sizes.
1101 set cmsghdr Cmsghdr ip_mreq IPMreq ip_mreqn IPMreqn ipv6_mreq IPv6Mreq \
1102 ifaddrmsg IfAddrmsg ifinfomsg IfInfomsg in_pktinfo Inet4Pktinfo \
1103 in6_pktinfo Inet6Pktinfo inotify_event InotifyEvent linger Linger \
1104 msghdr Msghdr nlattr NlAttr nlmsgerr NlMsgerr nlmsghdr NlMsghdr \
1105 rtattr RtAttr rtgenmsg RtGenmsg rtmsg RtMsg rtnexthop RtNexthop \
1106 sock_filter SockFilter sock_fprog SockFprog ucred Ucred
1107 while test $# != 0; do
1108 nc=$1
1109 ngo=$2
1110 shift
1111 shift
1112 if grep "^const _sizeof_$nc =" gen-sysinfo.go >/dev/null 2>&1; then
1113 echo "const Sizeof$ngo = _sizeof_$nc" >> ${OUT}
1115 done
1117 # In order to compile the net package, we need some sizes to exist
1118 # even if the types do not.
1119 if ! grep 'const SizeofIPMreq ' ${OUT} >/dev/null 2>&1; then
1120 echo 'const SizeofIPMreq = 8' >> ${OUT}
1122 if ! grep 'const SizeofIPv6Mreq ' ${OUT} >/dev/null 2>&1; then
1123 echo 'const SizeofIPv6Mreq = 20' >> ${OUT}
1125 if ! grep 'const SizeofIPMreqn ' ${OUT} >/dev/null 2>&1; then
1126 echo 'const SizeofIPMreqn = 12' >> ${OUT}
1129 exit $?